<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2015 IMIA net based solutions (dev@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaPageteaser\Hook;

use TYPO3\CMS\Core\DataHandling\DataHandler;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Utility\HttpUtility;
use TYPO3\CMS\Core\Utility\MathUtility;

/**
 * @package     imia_pageteaser
 * @subpackage  Utility
 * @author      David Frerich <d.frerich@imia.de>
 */
class ProcessDatamap
{
    /**
     * @param	string $status
     * @param	string $table
     * @param	mixed $id
     * @param	array $fields
     * @param	DataHandler $dataHandler
     */
    public function processDatamap_afterDatabaseOperations($status, $table, $id, &$fields, DataHandler &$dataHandler)
    {
		if (!MathUtility::canBeInterpretedAsInteger($id) && !empty($dataHandler->substNEWwithIDs[$id])) {
			$id = $dataHandler->substNEWwithIDs[$id];
        }

        if (MathUtility::canBeInterpretedAsInteger($id)) {
            switch ($table) {
                case 'pages':
                    if ($fields['create_language']) {
                        $l18nCfg = 1;
                        if (in_array((int)$fields['l18n_cfg'], array(2, 3))) {
                            $l18nCfg = 3;
                        }

                        $GLOBALS['TYPO3_DB']->exec_UPDATEquery($table, 'uid = ' . $id, array(
                            'create_language' => 0,
                            'l18n_cfg'        => $l18nCfg,
                            'hidden'          => 0,
                        ));

                        $overlayFields = $fields;
                        foreach ($overlayFields as $key => $value) {
                            if (!array_key_exists($key, $GLOBALS['TCA']['pages_language_overlay']['columns'])) {
                                unset($overlayFields[$key]);
                            }
                        }
                        $overlayFields['pid'] = $id;
                        $overlayFields['sys_language_uid'] = $fields['create_language'];

                        $GLOBALS['TYPO3_DB']->exec_INSERTquery('pages_language_overlay', $overlayFields);
                        $overlayId = $GLOBALS['TYPO3_DB']->sql_insert_id();

                        $returnUrl = GeneralUtility::_GP('returnUrl');
                        $columnsOnly = GeneralUtility::_GP('columnsOnly');
                        $columnsOnlyAlt = GeneralUtility::_GP('columnsOnlyAlt');
                        $columnsOnlyTS = GeneralUtility::_GP('columnsOnlyTS');

                        $params = array('edit[pages_language_overlay][' . $overlayId . ']=edit');
                        if ($columnsOnly) {
                            $params[] = 'columnsOnly=' . urlencode($columnsOnly);
                        }
                        if ($columnsOnlyAlt) {
                            $params[] = 'columnsOnlyAlt=' . urlencode($columnsOnlyAlt);
                        }
                        if ($columnsOnlyTS) {
                            $params[] = 'columnsOnlyTS=' . urlencode($columnsOnlyTS);
                        }
                        if ($returnUrl) {
                            $params[] = 'returnUrl=' . urlencode($returnUrl);
                        }
                        $params[] = 'pagelayout=1';

                        HttpUtility::redirect('alt_doc.php?' . implode('&', $params));
                    }
                    break;
            }
        }
    }
}