<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaPageteaser\ViewHelpers\Link;

/**
 * @package     imia_pageteaser
 * @subpackage  ViewHelpers
 * @author      David Frerich <d.frerich@imia.de>
 */
class AdditionalParamsViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper
{
    /**
     * @param object $page
     * @param object $indexPage
     * @return array
     */
    public function render(\TYPO3\CMS\Extbase\DomainObject\AbstractEntity $indexPage, \TYPO3\CMS\Extbase\DomainObject\AbstractEntity $page = null)
    {
        $additionalParams = array();
        if (!$page) {
            $page = $this->renderChildren();
        }

        if ($page) {
            // Mount page
            if ($indexPage->getDoktype() == 7) {
                if ($indexPage->getMountPid() == $page->getPid()) {
                    $additionalParams['MP'] = $indexPage->getMountPid() . '-' . $indexPage->getUid();
                } else {
                    $parentPage = array(
                        'pid' => $page->getPid(),
                    );

                    do {
                        $parentPage = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('doktype, pid', 'pages', 'uid = ' . $parentPage['pid']);
                    } while($parentPage && $parentPage['pid'] && $parentPage['pid'] != $indexPage->getMountPid());

                    if ($parentPage && $parentPage['pid'] == $indexPage->getMountPid()) {
                        $additionalParams['MP'] = $indexPage->getMountPid() . '-' . $indexPage->getUid();
                    }
                }
            }
        }

        return $additionalParams;
    }
}